// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers','ui.router','ngAnimate','LocalStorageModule','angular-md5'])

.run(function($ionicPlatform, $rootScope, $ionicPopup, $ionicLoading) {
  $ionicPlatform.ready(function() {
      $rootScope.noConnection = false;

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

      $rootScope.closePopupSucessProfile = function() {
          $ionicLoading.hide();
          return true;
      }


      if(window.Connection) {
          if(navigator.connection.type == Connection.NONE) {
              $ionicPopup.show({
                  title: "Internet Disconnected",
                  template: "The internet is disconnected on your device.",
                  scope: $rootScope,
                  buttons: [
                      {
                          text: 'Ok',
                          type: 'button-positive',
                          onTap: function () {
                              return $rootScope.closePopupSucessProfile()
                          }
                      }
                  ]
              });
              $rootScope.noConnection = true;
          }
      }
  });
})

    .filter('keylength', function(){
        return function(input){
            if(!angular.isObject(input)){
                throw Error("Usage of non-objects with keylength filter!!")
            }
            return Object.keys(input).length;
        }
    })

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })

    .state('app.mainPage', {
      url: "/mainPage",
      views: {
        'menuContent': {
          templateUrl: "templates/mainPage.html"
          //controller: 'PlaylistsCtrl'
        }
      }
    })
	
	.state('app.login', {
      url: "/login",
      views: {
        'menuContent': {
          templateUrl: "templates/login.html",
          controller: 'public-page-controller'
        }
      }
    })

      .state('app.statistics', {
          url: "/statistics/:ApplicationID/:JobID/:chartType",
          views: {
              'menuContent': {
                  templateUrl: "templates/statistics.html",
                  controller: 'applied-page-controller'
              }
          }
      })

	.state('app.register', {
      url: "/register",
      views: {
        'menuContent': {
          templateUrl: "templates/register.html",
          controller: 'public-page-controller'
        }
      }
    })
	
	.state('app.jobFeed', {
      url: "/jobFeed",
      views: {
        'menuContent': {
          templateUrl: "templates/jobFeed.html",
          controller: 'jobFeed-page-controller'
        }
      }
    })
	
	.state('app.filter', {
      url: "/filter",
      views: {
        'menuContent': {
          templateUrl: "templates/filter.html",
          controller: 'filter-page-controller'
        }
      }
    })
	
	.state('app.index', {
      url: "/index",
      views: {
        'menuContent': {
          templateUrl: "templates/index.html",
          controller: 'index-page-controller'
        }
      }
    })
	
	.state('app.appliedJob', {
      url: "/appliedJob",
      views: {
        'menuContent': {
          templateUrl: "templates/appliedJob.html",
          controller: 'applied-page-controller'
        }
      }
    })
	
	.state('app.jobView', {
      url: "/jobView/:ID",
      views: {
        'menuContent': {
          templateUrl: "templates/jobView.html",
          controller: 'jobView-page-controller'
        }
      }
    })
	
	/* :type parameter represent for Category or Subcategory { accept string value : CAT or SUB} */
	.state('app.jobListing', {
      url: "/jobListing/:categoryID/:subCategoryID/:subCategoryName",
      views: {
        'menuContent': {
          templateUrl: "templates/jobListing.html",
          controller: 'jobListing-job-controller'
        }
      }
    })
	
	.state('app.profile', {
      url: "/profile",
      views: {
        'menuContent': {
          templateUrl: "templates/profile.html",
          controller: 'profile-page-controller'
        }
      }
    })
	
	/*
  .state('app.single', {
    url: "/playlists/:playlistId",
    views: {
      'menuContent': {
        templateUrl: "templates/playlist.html",
        controller: 'PlaylistCtrl'
      }
    }
  }) */
  //;
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/index');
});
