angular.module('starter.controllers', ['ionic'])
    .controller('AppCtrl', function ($scope, $ionicSideMenuDelegate, $ionicPlatform ,md5, $location, $ionicPopover, $ionicPopup, $rootScope, $http, $ionicModal, $timeout, $ionicSideMenuDelegate, localStorageService) {
        $scope.User = {};
        $rootScope.messageTag = null;
        $rootScope.stringObject = {
            hostname: "http://www.jobsiit.com",
            mobileOrWebsite: 'mobile',
           // mobileOrWebsite: 'website',
            //hostname: 'http://192.168.137.201/jobsiit',
            indexPageString: "/mainmenues/mainMenuService",  //For Category and Sub category
            jobListingString: "/jobs/listingService/",
            jobView: "/jobs/jobListingDetailsService/",
            degreeMajaorList: "/Listings/listingElementsService",
            getComapnyList: "/Listings/listingCompanyService",
            loginString: "/users/loginWithMobile",
            getAppliedJob: "/applications/getAppliedJobFromMobile",
            applyForJob: "/jobs/applyFromMobile",
            displayJob: "/jobs/displayjobsForMobile",       //After filter
            signupString: "/users/addSeekerFromMobile",
            updateProfile: "/Seekers/updateProfileFromMobile",
            forgot_passwordString: "/users/forget_passwordForMobile/",
            signupWithSocialString: "/users/authenticateUserFromMobile",
            getStaticsData: "/jobs/prepare_bar_graphForMobile",
            daysDiff: 5
        };
        /*
         Get local creditanls Or check if user login or not
         */
        $rootScope.localUser = localStorageService.get('localUser');
        if ($rootScope.localUser) {
            $rootScope.isLoggedIn = true;
        }
        else {
            $rootScope.isLoggedIn = false;
        }

        /*
         Common method to show message in alert...
         accept title and value as input
         */
        $rootScope.showAlert = function (title, value) {
            var alertPopup = $ionicPopup.alert({
                title: title,
                template: value
            });
        };

        /*
         Get all listing data from local if exist
         else call api from server to get new data...
         */
        $ionicPlatform.ready(function() {
            $rootScope.showLocationData = [];
            var localListingData = localStorageService.get("listingData");
            if (localListingData) {
                var lastApiCallDate = new Date(new Date(localListingData.apiCallDate).getTime() + 24 * 60 * 60 * 1000);
                var cuuDateCall = new Date(new Date().getTime() + 24 * 60 * 60 * 1000);
                var timeDiff = cuuDateCall - lastApiCallDate;
                var diffDays = Math.floor(timeDiff / (1000 * 3600 * 24));
                if (diffDays >= $rootScope.stringObject.daysDiff) {
                    getServerListData();
                }
                else {
                    $rootScope.colleageList = localListingData.colleageList;
                    $rootScope.degreeList = localListingData.degreeList;
                    $rootScope.enggSkillsData = localListingData.enggSkillsData;
                    $rootScope.nonEnggSkillsData = localListingData.nonEnggSkillsData;
                    $rootScope.specificationList = localListingData.specificationList;
                    $rootScope.showLocationData = localListingData.showLocationData;
                    $rootScope.companyNameData = localListingData.companyNameData;
                    $rootScope.showSkillData = localListingData.showSkillData;
                }
            }
            else {
                getServerListData();
            }
        });

        function getServerListData() {   // Get listing data from server
            var responsePromiseDataList = $http.get($rootScope.stringObject.hostname + $rootScope.stringObject.degreeMajaorList);
            responsePromiseDataList.success(function (dataFromServer, status, headers, config) {
                if (typeof dataFromServer.institites !== "undefined") {
                    var listDataProfile = {};
                    var colleageList = [];
                    var companyNameData = [];
                    var showSkillData = [];
                    var showLocationData = [];
                    var degreeList = [];
                    var enggSkillsData = [];
                    var nonEnggSkillsData = [];
                    var specificationList = [];

                    for (var i = 0; i < dataFromServer.institites.length; i++) {
                        colleageList.push({ id: i, collegeName: dataFromServer.institites[i].Listing.listing });
                    }

                    for (comanyName in dataFromServer.company) {
                        if (dataFromServer.company[comanyName] !== '') {
                            companyNameData.push({ name: dataFromServer.company[comanyName] });
                        }
                    }

                    for (skills in dataFromServer.combineSkills) {
                        if (skills) {
                            showSkillData.push({ name: dataFromServer.combineSkills[skills] });
                        }
                    }

                    Object.keys(dataFromServer.locations).forEach(function (location) {
                        if (location) {
                            showLocationData.push({ name: dataFromServer.locations[location] });
                        }
                    });

                    for (var i = 0; i < dataFromServer.majors.length; i++) {
                        specificationList.push({ id: i, specName: dataFromServer.majors[i].Listing.listing });
                    }


                    for (var i = 0; i < dataFromServer.degrees.length; i++) {
                        degreeList.push({ id: i, degreeName: dataFromServer.degrees[i].Listing.listing });
                    }

                    for (var i = 0; i < dataFromServer.Engskiils.length; i++) {
                        enggSkillsData.push({ id: i, name: dataFromServer.Engskiils[i].Listing.listing });
                    }

                    for (var i = 0; i < dataFromServer.NonEngskiils.length; i++) {
                        nonEnggSkillsData.push({ id: i, name: dataFromServer.NonEngskiils[i].Listing.listing });
                    }

                    $rootScope.showLocationData = showLocationData;
                    $rootScope.companyNameData = companyNameData;
                    $rootScope.showSkillData = showSkillData;
                    $rootScope.colleageList = colleageList;
                    $rootScope.degreeList = degreeList;
                    $rootScope.enggSkillsData = enggSkillsData;
                    $rootScope.nonEnggSkillsData = nonEnggSkillsData;
                    $rootScope.specificationList = specificationList;
                    var apiCallDate = new Date();
                    listDataProfile = { "companyNameData": companyNameData, "showLocationData": showLocationData, "showSkillData": showSkillData, "colleageList": colleageList, "specificationList": specificationList, "degreeList": degreeList, "enggSkillsData": enggSkillsData, "nonEnggSkillsData": nonEnggSkillsData, "apiCallDate": apiCallDate};
                    localStorageService.set('listingData', listDataProfile);

                }
                else {
                    $scope.passreseterror = "Internal server error";
                }

            });
            responsePromiseDataList.error(function (data, status, headers, config) {
                $scope.passreseterror = data.error;
            });
        }


        $scope.upgradePlan = function() {
            $ionicPopup.show({
                template: 'Please upgrade plan by visiting JobsIIT website.',
                title: 'Message Box',
                scope: $scope,
                buttons: [
                    {
                        text: 'Ok',
                        type: 'button-positive',
                        onTap: function () {
                            return true;
                        }
                    }
                ]
            });
            $scope.popover.hide();
        }

        $ionicPopover.fromTemplateUrl('popover-menu.html', {
            scope: $scope
        }).then(function (popover) {
            $scope.popover = popover;
        });

        $rootScope.openPopover = function ($event) {
            $scope.popover.show($event);
        };
        $rootScope.closePopover = function () {
            $scope.popover.hide();
        };
        //Cleanup the popover when we're done with it!
        $rootScope.$on('$destroy', function () {
            $scope.popover.remove();
        });
        // Execute action on hide popover
        $rootScope.$on('popover.hidden', function () {
            // Execute action
        });
        // Execute action on remove popover
        $rootScope.$on('popover.removed', function () {
            // Execute action
        });



        /*
        $rootScope.jobFeedClick = function() {
            if($rootScope.isLoggedIn) {
                $location.url("/app/jobListing/JobsFeed//");
            }
            else {
                //$location.url("/app/login");
            }
        };*/


        /*
         Gobal function to close any pop up...
         */
        $rootScope.closePopup = function () {
            return true;
        }

        $scope.logout = function () {   // Logout the user and remove all data for current user.....
            localStorageService.remove('localUser');
            localStorage.removeItem('hello');
            $rootScope.localUser = null;
            $scope.popover.hide();
            $rootScope.currUserID = null;
            $rootScope.isLoggedIn = false;
            $location.url("/app/index");
        };

        $scope.toggleLeftSideMenu = function () {
            $ionicSideMenuDelegate.toggleLeft();
        };

        $scope.isSubCategoryClose = true;

        $scope.isSubCategoryChangeAction = function () {
            $scope.toggleLeftSideMenu();
            $scope.isSubCategoryClose = true;
            setTimeout(function () {
                $scope.toggleLeftSideMenu();
            }, 200);
        }

        $scope.isSubCategoryCloseAction = function () {
            $scope.toggleLeftSideMenu();
            $scope.isSubCategoryClose = true;
        };

        $scope.currMainMenuID = '';
        $scope.subCategoryList = function (categoryObj) {
            $scope.currMainMenuID = categoryObj.id;
            var listIcon = [];
            $scope.subCategoryMenu = [];

            $scope.toggleLeftSideMenu();
            for (var i = 0; i < $scope.listData.length; i++) {
                if ($scope.listData[i].Mainmenue.id == categoryObj.id) {
                    $scope.subCategoryListData = $scope.listData[i].Submenue;
                }
            }

            if ($scope.subCategoryListData.length !== 0) {
                $scope.isSubCategoryClose = false;
                for (var i = 0; i < $scope.categoryData.length; i++) {
                    listIcon.push($scope.categoryData[i].icons);
                }
                var resultLength;
                if (listIcon.length > $scope.subCategoryListData.length) {
                    resultLength = listIcon.length
                }
                else {
                    resultLength = $scope.subCategoryListData.length
                }


                for (var i = 0; i < resultLength; i++) {
                    var obj = {};
                    if ($scope.subCategoryListData[i]) {
                        obj.id = $scope.subCategoryListData[i].id;
                        obj.title = $scope.subCategoryListData[i].menu;
                    }
                    else {
                        obj.title = '';
                    }

                    if (listIcon[i]) {
                        obj.icon = listIcon[i];
                    }
                    else {
                        obj.icon = "";
                    }
                    $scope.subCategoryMenu.push(obj);
                }
                setTimeout(function () {
                    $scope.toggleLeftSideMenu();
                }, 200);
            }
            else {
                $scope.isSubCategoryClose = true;
                $location.url("/app/jobListing/" + categoryObj.id + "//" + categoryObj.menu);
            }

        };

        // $scope.categoryMenu = [];
        $scope.categoryData = [];

        // $scope.listData = localStorageService.get('localUser');
        //  $scope.categoryData = localStorageService.get('localCategoryData');

        $ionicPlatform.ready(function() {
            var localMenuData = localStorageService.get('localDataSideMenu');
            if (localMenuData) {
                var lastApiCallDate = new Date(new Date(localMenuData.apiCallDate).getTime() + 24 * 60 * 60 * 1000);
                var cuuDateCall = new Date(new Date().getTime() + 24 * 60 * 60 * 1000);
                var timeDiff = cuuDateCall - lastApiCallDate;
                var diffDays = Math.floor(timeDiff / (1000 * 3600 * 24));
                if (diffDays >= $rootScope.stringObject.daysDiff) {
                    getSideMenuData();

                }
                else {
                    $scope.listData = localMenuData.localListData;
                    $scope.categoryData = localMenuData.localCategoryData;
                }
            }
            else {
                getSideMenuData();
            }
        });

        /* Side Menu Creation.... bind with server data */

        function getSideMenuData() {
            var responsePromiseForCategoryList = $http.get($rootScope.stringObject.hostname + $rootScope.stringObject.indexPageString);
            responsePromiseForCategoryList.success(function (response, status, headers, config) {
                $scope.listData = response;
                for (var i = 0; i < response.length; i++) {
                    $scope.categoryData.push(response[i].Mainmenue);
                }
                var apiCallDate = new Date();
                // localStorageService.set('localListData', $scope.listData);
                // localStorageService.set('localCategoryData', $scope.categoryData);
                var localDataSideMenu = {"localListData" : $scope.listData, "localCategoryData" : $scope.categoryData, "apiCallDate" : apiCallDate };
                localStorageService.set('localDataSideMenu',localDataSideMenu);
            });

            responsePromiseForCategoryList.error(function (data, status, headers, config) {
                $scope.error = data.error;
            });
        }

        /********************* Side Menu Creation End ******************/
    })

    .controller('public-page-controller', function ($scope, $rootScope, $location, $ionicLoading, $http, localStorageService, md5) {

        // Hello.js Functions
        hello.init({
                facebook: '710192189100457',
                google: '824970815631-pvkurckd499g7u6s2eqbcs65f48ugbsc.apps.googleusercontent.com',
                linkedin: '78n6du1f1r0gjm'
            }
            , {
                response_type: 'code',
                oauth_proxy : 'https://auth-server.herokuapp.com/proxy'
            }
        );

        if (!$rootScope.isLoggedIn) {
            $scope.loginWithSocialMedia = function (provider) {
                $ionicLoading.show({
                    template: '<i class="fa fa-spinner fa-spin"></i> Loading..'
                });
                redirecturi = '';
                response_type = '';
                var display = 'page';

                if(provider == 'facebook') {
                    redirecturi = $rootScope.stringObject.hostname+'/app/webroot/mobile';
                    if($rootScope.stringObject.mobileOrWebsite == 'mobile') {
                        redirecturi = 'https://www.facebook.com/connect/login_success.html';
                    }
                    response_type = 'token';
                }
                if(provider == 'google'){
                    redirecturi = $rootScope.stringObject.hostname+'/app/webroot/mobile';
                    if($rootScope.stringObject.mobileOrWebsite == 'mobile') {
                        redirecturi = 'http://adodson.com/hello.js/redirect.html';
                    }
                    response_type = 'token';
                }
                if(provider == 'linkedin') {
                    redirecturi = $rootScope.stringObject.hostname+'/app/webroot/mobile';
                    if($rootScope.stringObject.mobileOrWebsite == 'mobile') {
                        redirecturi = 'http://adodson.com/hello.js/redirect.html';

                    }
                    response_type = 'code';
                }

                if($rootScope.stringObject.mobileOrWebsite == 'mobile') {
                    display = 'popup';
                }

                // Update display in option
                //display : 'popup' for App
                //display : 'page' for Browser

                hello().login(provider, {scope: "email", display: display, redirect_uri: redirecturi, response_type: response_type }, function () {
                    $ionicLoading.show({
                        template: '<i class="fa fa-spinner fa-spin"></i> Loading..'
                    });

                    var obj = {};
                    var token = hello(provider).getAuthResponse().access_token;
                    if(typeof token !== null) {
                        obj.provide = provider;
                        obj.token = token;
                        var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.signupWithSocialString, obj, {});
                        responsePromise.success(function (dataFromServer, status, headers, config) {
                            if (typeof dataFromServer.User !== "undefined") {
                                $rootScope.currUserID = dataFromServer.User.id;
                                var obj = {};
                                obj.username = dataFromServer.User.username;
                                obj.password = dataFromServer.User.password;
                                localStorageService.set('localUser', obj);
                                $rootScope.isLoggedIn = true;
                                var currentJobID = localStorageService.get('localJobID');
                                if (dataFromServer.Seeker.phone) {
                                    if (currentJobID) {
                                        $location.url("/app/jobView/" + currentJobID);
                                    }
                                    else {
                                        $location.url("/app/index");
                                    }
                                }
                                else {
                                    $location.url("/app/profile");
                                }
                                $ionicLoading.hide();
                            }
                            else if(dataFromServer == 'invalidUser') {
                                $rootScope.messageTag = "Only job seeker can login from mobile app.";
                                $ionicLoading.hide();
                            }
                        });
                        responsePromise.error(function (data, status, headers, config) {
                            $scope.passreseterror = data.error;
                            $ionicLoading.hide();
                        });

                    }
                    else {
                        $ionicLoading.hide();
                    }
                });
                setTimeout(function(){$ionicLoading.hide(); }, 3000);
            }
            $scope.loginData = {};
            $scope.newUser = {};
            $scope.passreseterror = null;
            $scope.passwordValidate = null;
            $scope.usernameValidate = null;
            $rootScope.messageTag = null;
            $scope.forgot_password = function (email) {
                if (email) {
                    var promiseForgotPassword = $http.get($rootScope.stringObject.hostname + $rootScope.stringObject.forgot_passwordString + email);
                    promiseForgotPassword.success(function (response, status, headers, config) {
                        if (typeof response.sucess !== "undefined") {
                            $rootScope.showAlert('Message', response.sucess);
                        }
                        else {
                            $scope.usernameValidate = 0;
                            $rootScope.messageTag = response;
                        }

                    });

                    promiseForgotPassword.error(function (data, status, headers, config) {
                        $scope.error = data.error;
                    });
                }
                else {
                    $scope.usernameValidate = 0;
                    $rootScope.messageTag = "Please enter valid email";
                }
            };

            $scope.login = function (obj) {
                if (obj.username) {
                    if (!obj.password || obj.password.length < 6) {
                        $scope.passwordValidate = 0;
                        $rootScope.messageTag = "Please enter valid password";
                    }
                    else {
                        $rootScope.messageTag = null;
                        obj.password = md5.createHash(obj.password);
                        var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.loginString, obj, {});
                        responsePromise.success(function (dataFromServer, status, headers, config) {
                            if (typeof dataFromServer.User !== "undefined") {
                                $rootScope.currUserID = dataFromServer.User.id;
                                localStorageService.set('localUser', obj);
                                $rootScope.localUser = obj;
                                $rootScope.isLoggedIn = true;
                                var currentJobID = localStorageService.get('localJobID');
                                var isJobFeed = localStorageService.get('isJobFeed');

                                if (dataFromServer.Seeker.phone) {
                                    if (currentJobID) {
                                        $location.url("/app/jobView/" + currentJobID);
                                    }
                                    else {
                                        if(isJobFeed)
                                            $location.url("/app/jobListing/JobsFeed//");
                                        else
                                            $location.url("/app/index");
                                    }
                                }
                                else {
                                    $location.url("/app/profile");
                                }

                            }
                            else if(dataFromServer == '"invalidUser"') {
                                $rootScope.messageTag = "Only job seeker can login from mobile app.";
                                $scope.passwordValidate = 0;
                                $scope.usernameValidate = 0;
                            }
                            else {
                                $rootScope.messageTag = "Invalid Email or Password!";
                                $scope.passwordValidate = 0;
                                $scope.usernameValidate = 0;

                            }
                        });
                        responsePromise.error(function (data, status, headers, config) {
                            $rootScope.messageTag = data.error;
                        });
                    }
                }
                else {
                    $scope.usernameValidate = 0;
                    $rootScope.messageTag = " Please enter valid email!";
                }
            };

            $scope.signup = function (obj) {
                $scope.signupError = null;
                $scope.emailAddressValidate = null;
                $scope.passwordValidate = null;
                if (obj.name && obj.password) {
                    if (obj.username) {
                        if (obj.password.length >= 6) {
                            obj.comeFromType = 'local';
                            var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.signupString, obj, {});
                            responsePromise.success(function (dataFromServer, status, headers, config) {
                                if (typeof dataFromServer.User !== "undefined") {
                                    $rootScope.currUserID = dataFromServer.User.id;
                                    $scope.signupError = null;
                                    obj.password = dataFromServer.User.password;
                                    localStorageService.set('localUser', obj);
                                    $rootScope.isLoggedIn = true;
                                    $location.url("/app/profile");
                                }
                                else {
                                    $scope.signupError = dataFromServer;
                                }
                            });
                            responsePromise.error(function (data, status, headers, config) {
                                $scope.passreseterror = data.error;
                            });
                        }
                        else {
                            $scope.signupError = "At least 6 characters long";
                            $scope.passwordValidate = 0;
                        }

                    } else {
                        $scope.emailAddressValidate = 0;
                        $scope.signupError = "Please enter valid email address.";
                    }
                }
                else {
                    $scope.signupError = "Please fill out all the field";
                }
            };
        }
        else {
            $location.url('/app/profile/');
        }


    })

    .controller('applied-page-controller', function ($scope, $state, $location, localStorageService, $rootScope, $http, $ionicLoading, $ionicPopup) {
        $scope.jobFeedClick = function() {
            if($rootScope.isLoggedIn) {
                $location.url("/app/jobListing/JobsFeed//");
            }
            else {
                $location.url("/app/login");
            }
        };
        if ($rootScope.isLoggedIn) {

            $scope.getCurrentApplicationData = function (obj) {
                $rootScope.applicationRecivedForCurID = obj.appRecived;
                $rootScope.applicationStaticsData = [
                    {
                        key: "Cumulative Return",
                        values: [
                            {
                                "label": "Views",
                                "value": parseInt(obj.views)
                            } ,
                            {
                                "label": "Application Received",
                                "value": parseInt(obj.appRecived)
                            } ,
                            {
                                "label": "Recruiter Action",
                                "value": parseInt(obj.recruiterAction)
                            } ,
                            {
                                "label": "Shortlisted",
                                "value": parseInt(obj.shortListCount)
                            },
                            {
                                "label": "Rejected(By Recruiter / JobsIIT)",
                                "value": parseInt(obj.rejected_count)
                            }
                        ]
                    }
                ];
            }

            $rootScope.nodataMessage = null;
            $scope.appliedJobData = [];
            $ionicLoading.show({
                template: '<i class="fa fa-spinner fa-spin"></i> Loading..'
            });
            $scope.showStatus = function (status, message) {
                var alertPopup = $ionicPopup.alert({
                    title: 'Status : ' + status,
                    template: 'Discription : ' + message
                });
            }
            var localObject = localStorageService.get('localUser');
            var jobID = $state.params['JobID'];
            var applicationID = $state.params['ApplicationID'];
            var chartType = $state.params['chartType'];

            if (jobID && applicationID && chartType) {
                $scope.pieChart = false;
                $scope.ChartTypeCurrent = null;
                $scope.isApplicationGraph = true;
                $scope.isRank = false;
                $scope.isRankGraph = false;
                $scope.isExperienceGraph = false;
                $scope.iscandidatesQualification = false;
                /*
                 if (chartType == 'pieChart') {
                 $scope.pieChart = true;
                 $scope.ChartTypeCurrent = 'Candidates Qualification';
                 }
                 */


                $scope.candidateQualificationData = [];
                var experienceDataObj = [];
                localObject.jobID = jobID;
                localObject.applicationID = applicationID;
                var responsePromiseGetStaticsData = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.getStaticsData, localObject, {});
                responsePromiseGetStaticsData.success(function (dataFromServer, status, headers, config) {
                    for (data in dataFromServer.institute_count[0][0]) {
                        var type = '';
                        if (data == 'iit') type = 'IIT';
                        if (data == 'other') type = 'Others';
                        if (data == 'total') type = 'TOP ENGG';
                        if (data == 'nit') type = 'NIT';
                        $scope.candidateQualificationData.push({ "label": type, "value": parseInt(dataFromServer.institute_count[0][0][data])});
                    }

                    $scope.totalAppRecived = dataFromServer.totalApplicationRecived;
                    if (dataFromServer.rank == 'In Progress ...') {
                        $scope.isRank = false;
                        $scope.rank = 200 / 2;
                        $scope.actualRank = dataFromServer.rank;
                    }

                    else {
                        var scale = 210 / parseInt(dataFromServer.totalApplicationRecived);
                        $scope.rank = scale * dataFromServer.rank;
                        if($scope.rank < 1) {
                            $scope.rank = 210
                        }
                        $scope.actualRank = dataFromServer.rank;
                    }


                    for (data in dataFromServer.exp_count[0][0]) {
                        var type = '';
                        if (data == '1_3') type = '1-3 Yr';
                        if (data == '3_5') type = '3-5 Yr';
                        if (data == '5_10') type = '5-10 Yr';
                        if (data == '10_15') type = '10-15 Yr';
                        if (data == 'lessthan1') type = '< 1 Yr';
                        if (data == '15above') type = '15+ Yr';
                        experienceDataObj.push({ "label": type, "value": parseInt(dataFromServer.exp_count[0][0][data])});
                    }
                    // var experienceStaticsObj =
                    $scope.experienceStaticsData = [
                        {
                            key: "Cumulative Return",
                            values: experienceDataObj
                        }
                    ];
                    // $ionicLoading.hide();
                });
                responsePromiseGetStaticsData.error(function (data, status, headers, config) {
                    $scope.passreseterror = data.error;
                    $ionicLoading.hide();
                });
                $scope.candidatesQualification = function () {
                    nv.addGraph(function () {
                        var chart = nv.models.pieChart()
                            .x(function (d) {
                                return d.label
                            })
                            .y(function (d) {
                                return d.value
                            })
                            .showLabels(true);

                        d3.select("#chart svg")
                            .datum($scope.candidateQualificationData)
                            .transition().duration(350)
                            .call(chart);

                        return chart;
                    });
                    $scope.iscandidatesQualification = true;
                    $scope.isExperienceGraph = false;
                    $scope.isRankGraph = false;
                    $scope.isApplicationGraph = false;
                    $scope.ChartTypeCurrent = 'Candidates Qualification';
                    // $scope.showBarChart($scope.experienceStaticsData);
                }
                $scope.scriptLoded = false;
                $scope.showBarChart = function (obj) {
                    if ($scope.scriptLoded == false) {
                        $.getScript("lib/ionic/js/chart/d3.min.js", function (data, textStatus, jqxhr) {
                            nv.addGraph(function () {
                                var chart = nv.models.discreteBarChart()
                                        .x(function (d) {
                                            return d.label
                                        })    //Specify the data accessors.
                                        .y(function (d) {
                                            return d.value
                                        })
                                        .staggerLabels(false)    //Too many bars and not enough room? Try staggering labels.
                                        .tooltips(false)        //Don't show tooltips
                                        .showValues(true)       //...instead, show the bar value right on top of each bar.
                                        .transitionDuration(350)
                                    ;
                                chart.valueFormat(d3.format('d'));
                                chart.margin({bottom: 180});
                                chart.xAxis
                                    .staggerLabels(false)
                                    .rotateLabels(-40);
                                //.axisLabel("Title of the Chart")


                                d3.select('#chart svg')
                                    .datum(obj) //$rootScope.applicationStaticsData)
                                    .call(chart);

                                nv.utils.windowResize(chart.update);

                                return chart;
                            });
                        });


                    }
                    else{
                        nv.addGraph(function () {
                            var chart = nv.models.discreteBarChart()
                                    .x(function (d) {
                                        return d.label
                                    })    //Specify the data accessors.
                                    .y(function (d) {
                                        return d.value
                                    })
                                    .staggerLabels(true)    //Too many bars and not enough room? Try staggering labels.
                                    .tooltips(false)        //Don't show tooltips
                                    .showValues(true)       //...instead, show the bar value right on top of each bar.
                                    .transitionDuration(350)
                                ;


                            d3.select('#chart svg')
                                .datum(obj) //$rootScope.applicationStaticsData)
                                .call(chart);

                            nv.utils.windowResize(chart.update);

                            return chart;
                        });

                    }
                }

                $scope.showBarChart($scope.applicationStaticsData);
                $scope.ChartTypeCurrent = 'Job Application Statistics';

                $scope.experienceGraph = function () {
                    $scope.isExperienceGraph = true;
                    $scope.isRankGraph = false;
                    $scope.iscandidatesQualification = false;
                    $scope.isApplicationGraph = false;
                    $scope.showBarChart($scope.experienceStaticsData);
                    $scope.ChartTypeCurrent = 'Distribution of applications by experience(yrs)';
                }

                $scope.rankGraph = function () {
                    $scope.iscandidatesQualification = false;
                    $scope.isExperienceGraph = false;
                    $scope.isApplicationGraph = false;
                    $scope.isRankGraph = true;
                    $scope.ChartTypeCurrent = 'Rank Comparision';
                }

                $scope.showApplicationGraph = function () {
                    $scope.iscandidatesQualification = false;
                    $scope.isApplicationGraph = true;
                    $scope.isExperienceGraph = false;
                    $scope.isRankGraph = false;
                    $scope.showBarChart($scope.applicationStaticsData);
                }
            }


            //  var localObject = localStorageService.get('localUser');
            var exampleData = [];
            var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.getAppliedJob, localObject, {});
            responsePromise.success(function (dataFromServer, status, headers, config) {
                if (dataFromServer.length !== 0) {
                    for (var i = 0; i < dataFromServer.length; i++) {

                        if (dataFromServer[i].Jobs.title.length > 20) {
                            dataFromServer[i].Jobs.title = dataFromServer[i].Jobs.title.substr(0, 20) + "...";
                        }

                        if (dataFromServer[i][0].JobLocation.length > 15) {
                            dataFromServer[i][0].JobLocation = dataFromServer[i][0].JobLocation.substr(0, 15) + "...";
                        }
                        $scope.appliedJobData.push(
                            {
                                'id': dataFromServer[i].Application.ID,
                                'jobTitle': dataFromServer[i].Jobs.title,
                                'job_id': dataFromServer[i].Jobs.ID,
                                'min_exp': dataFromServer[i].Jobs.min_exp,
                                'max_exp': dataFromServer[i].Jobs.max_exp,
                                'min_compen': dataFromServer[i].Jobs.min_compen,
                                'max_compen': dataFromServer[i].Jobs.max_compen,
                                'appliedOn': dataFromServer[i].Application.date,
                                'location': dataFromServer[i][0].JobLocation,
                                'views': dataFromServer[i].Jobs.views,
                                'appRecived': dataFromServer[i].Jobs.application_received,
                                'recruiterAction': dataFromServer[i].Jobs.recruiter_action_count,
                                'shortListCount': dataFromServer[i].Jobs.shortlisted_count,
                                'rejected_count': dataFromServer[i].Jobs.rejected_count,
                                'status': dataFromServer[i].Application.viewstatus,
                                'message': dataFromServer[i].Application.message,
                                'plan': parseInt(dataFromServer[i].Seeker.seeker_plans_id)
                            });
                    }
                }
                else {
                    $rootScope.nodataMessage = 'No data available.';
                }
                $ionicLoading.hide();
            });
            responsePromise.error(function (data, status, headers, config) {
                $scope.passreseterror = data.error;
                $ionicLoading.hide();
            });

            $scope.toggleGroup = function (appliedJobData) {
                if ($scope.isCategoryShown(appliedJobData)) {
                    $scope.shownCategory = null;
                } else {
                    $scope.shownCategory = appliedJobData;
                }
            };

            $scope.isCategoryShown = function (appliedJobData) {
                return $scope.shownCategory === appliedJobData;
            };
        }
        else {
            $location.url('/app/index');
        }
    })

    .controller('jobView-page-controller', function ($scope, $rootScope, $state, $http, $sce, $ionicPopup, localStorageService, $location) {
        var jobID = $state.params['ID'];
        if (jobID) {
            var responsePromiseForJobLisiting = $http.get($rootScope.stringObject.hostname + $rootScope.stringObject.jobView + jobID);
            responsePromiseForJobLisiting.success(function (response, status, headers, config) {
                if (response.Job.max_compen == 5000) {
                    response.Job.max_compen = "No Bar";
                }
                $scope.jobViewData = { id: response.Job.ID, jobTitle: response.Job.title, exp: response.Job.min_exp + ' - ' + response.Job.max_exp + ' Yr', ctc: response.Job.min_compen + ' - ' + response.Job.max_compen + ' L', company: response.Job.company,
                    eligibilityCriteria: $sce.trustAsHtml(response.Job.eligibility),
                    aboutComapny: $sce.trustAsHtml(response.Job.about),
                    jobDescription: $sce.trustAsHtml(response.Job.text),
                    jobSkills: response['0'].JobSkills
                };
                var jobLocation = '';
                for (var i = 0; i < response.JobLocation.length; i++) {
                    if (response.JobLocation[i]) {
                        jobLocation += response.JobLocation[i].location + " ,";
                    }
                }
                $scope.jobLocationStr = jobLocation.slice(0, -1);
            });

            responsePromiseForJobLisiting.error(function (data, status, headers, config) {
                $scope.error = data.error;
            });
        }

        $scope.closePopupNotLoggedIn = function () {
            $location.url('/app/login');
            return true;
        }

        $scope.closePopupUpdateProfile = function () {
            //$location.url('/app/profile');
            return true;
        }

        $rootScope.applyForJob = function (job_id) {
            if ($rootScope.isLoggedIn) {
                var localObj = localStorageService.get('localUser');
                if(localObj) {
                    localObj.jobID = job_id;
                    var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.applyForJob, localObj, {});
                    responsePromise.success(function (dataFromServer, status, headers, config) {
                        if (dataFromServer == 1) {
                            $ionicPopup.show({
                                template: 'Please upload resume by visiting JobsIIT website.',
                                title: 'Message Box',
                                scope: $scope,
                                buttons: [
                                    {
                                        text: 'Ok',
                                        type: 'button-positive',
                                        onTap: function () {
                                            return $scope.closePopupUpdateProfile()
                                        }
                                    }
                                ]
                            });
                        }
                        else {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Message :)',
                                template: dataFromServer
                            });
                            localStorageService.set('localJobID', null);
                        }
                    });
                    responsePromise.error(function (data, status, headers, config) {
                        $scope.passreseterror = data.error;
                    });
                }
            }
            else {
                localStorageService.set('localJobID', job_id);
                $ionicPopup.show({
                    template: 'Please login to access this. We are redirecting you to Login page.',
                    title: 'Message Box',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'Ok',
                            type: 'button-positive',
                            onTap: function () {
                                return $scope.closePopupNotLoggedIn()
                            }
                        }
                    ]
                });
            }
        };

        var currentJobID = parseInt(localStorageService.get('localJobID'));
        var checkNan= isNaN(currentJobID);
        if (!checkNan)  $rootScope.applyForJob(currentJobID);
    })

    .controller('filter-page-controller', function ($scope, $location, $ionicPlatform, $ionicPopup, localStorageService, $rootScope, $http) {
        $scope.skillsFilter = $rootScope.showSkillData;
        $scope.filterJobObj = {};
        if($rootScope.currentFilterJob) {
            $scope.filterJobObj.companies = $rootScope.currentFilterJob.companies;
            if ($rootScope.currentFilterJob.companieList.length > 20) {
                $rootScope.currentFilterJob.companieList = $rootScope.currentFilterJob.companieList.substr(0, 20) + "...";
            }
            $scope.companiesStr = $rootScope.currentFilterJob.companieList;

            $scope.filterJobObj.skills = $rootScope.currentFilterJob.skills;
            if ($rootScope.currentFilterJob.skillList.length > 20) {
                $rootScope.currentFilterJob.skillList = $rootScope.currentFilterJob.skillList.substr(0, 20) + "...";
            }
            $scope.skillsStr = $rootScope.currentFilterJob.skillList;

            $scope.filterJobObj.locations = $rootScope.currentFilterJob.locations;
            if ($rootScope.currentFilterJob.locationList.length > 20) {
                $rootScope.currentFilterJob.locationList = $rootScope.currentFilterJob.locationList.substr(0, 20) + "...";
            }
            $scope.locationsStr = $rootScope.currentFilterJob.locationList;
        }

        $scope.$watch('filterJobObj.locationFilter', function (newValue, oldValue) {
            if (typeof newValue !== "undefined") {
                if (newValue !== oldValue) {
                    var locationFilterData = [];
                    for (var filter = 0; filter < $rootScope.showLocationData.length; filter++) {
                        var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.showLocationData[filter].name.toLowerCase());
                        if (boolResult)  locationFilterData.push({ name: $rootScope.showLocationData[filter].name});
                    }
                    $scope.locationFilter = locationFilterData;
                }
            }
            else {
                $scope.locationFilter = $rootScope.showLocationData;
            }
        });

        $scope.$watch('filterJobObj.skillsFilter', function (newValue, oldValue) {
            if (typeof newValue !== "undefined") {
                if (newValue !== oldValue) {
                    var skillsFilterData = [];
                    for(var filter = 0; filter < $rootScope.showSkillData.length; filter++) {
                        var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.showSkillData[filter].name.toLowerCase());
                        if(boolResult) {
                            skillsFilterData.push({ name : $rootScope.showSkillData[filter].name});
                        }
                    }
                    $scope.skillsFilter = skillsFilterData;
                }
            }
            else {
                $scope.skillsFilter = $rootScope.showSkillData;
            }
        });
        $scope.$watch('filterJobObj.companyFilter', function (newValue, oldValue) {
            if (typeof newValue !== "undefined") {
                if (newValue !== oldValue) {
                    var companyFilterData = [];
                    for (var filter = 0; filter < $scope.companyNameData.length; filter++) {
                        var boolResult = new RegExp('^' + newValue.toLowerCase()).test($scope.companyNameData[filter].name.toLowerCase());
                        if (boolResult) {
                            companyFilterData.push({ name: $scope.companyNameData[filter].name});
                        }
                    }
                    $scope.companyFilter = companyFilterData;
                }
            }
            else {
                $scope.companyFilter = $scope.companyNameData;
            }
        });
        $scope.filterPopUp = function (templateUrl)
        {
            $scope.activePopUp = $ionicPopup.show({
                templateUrl: templateUrl,
                title: 'Select',
                scope: $scope,
                buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
                    text: 'Cancel',
                    type: 'button-default',
                    onTap: function(e) {
                        return $rootScope.closePopup()
                    }
                }, {
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        return filterSelectedValue(templateUrl)
                    }
                }]
            });
        };

        function filterSelectedValue(templateUrl) {
            if(templateUrl == 'companyList.html') {
                var companiesStr = '';
                for (company in $scope.filterJobObj.companies) {
                    if (company) {
                        if ($scope.filterJobObj.companies[company]) {
                            companiesStr += company + ",";
                        }
                    }
                }
                if (companiesStr.length > 20) {
                    companiesStr = companiesStr.substr(0, 20) + "...";
                }
                $scope.companiesStr = companiesStr;
            }
            if(templateUrl == 'skillsList.html') {
                var skillsStr = '';
                for (skills in $scope.filterJobObj.skills) {
                    if (skills) {
                        if ($scope.filterJobObj.skills[skills]) {
                            skillsStr += skills + ",";
                        }
                    }
                }
                if (skillsStr.length > 20) {
                    skillsStr = skillsStr.substr(0, 20) + "...";
                }
                $scope.skillsStr = skillsStr;
            }
            if(templateUrl == 'locationList.html') {
                var locationsStr = '';
                for (locations in $scope.filterJobObj.locations) {
                    if (locations) {
                        if ($scope.filterJobObj.locations[locations]) {
                            locationsStr += locations + ",";
                        }
                    }
                }
                if (locationsStr.length > 20) {
                    locationsStr = locationsStr.substr(0, 20) + "...";
                }
                $scope.locationsStr = locationsStr;
            }

            return true;
        }

        window.onpopstate=function() {
            if($scope.activePopUp) {
                $scope.activePopUp.close();   //Close Popup when user tap on browser back button....
            }
        }
        /* ===================== End of Skills List ===================== */
        $scope.filterJob = function (dataObj) {
            var companiesStr = '';
            var locationsStr = '';
            var skillsStr = '';
            for (company in dataObj.companies) {
                if (company) {
                    if (dataObj.companies[company]) {
                        companiesStr += company + ",";
                    }
                }
            }
            for (locations in dataObj.locations) {
                if (locations) {
                    if (dataObj.locations[locations]) {
                        locationsStr += locations + ",";
                    }
                }
            }
            for (skills in dataObj.skills) {
                if (skills) {
                    if (dataObj.skills[skills]) {
                        skillsStr += skills + ",";
                    }
                }
            }
            if (!dataObj.min_exp) {
                dataObj.min_exp = 0;
            }

            if (!dataObj.max_exp) {
                dataObj.max_exp = 50;
            }

            if (!dataObj.min_compen) {
                dataObj.min_compen = 0;
            }

            if (!dataObj.max_compen) {
                dataObj.max_compen = 5010;
            }
            dataObj.companieList = companiesStr.slice(0, -1);
            dataObj.locationList = locationsStr.slice(0, -1);
            dataObj.skillList = skillsStr.slice(0, -1);
            $rootScope.currentFilterJob = dataObj;
            $location.url('/app/jobListing///');
        };
    })

    .controller('jobFeed-page-controller', function ($scope) {
        $scope.jobFeedData = [
            { id: '1', jobTitle: 'Java Developer', exp: '10 years', location: 'banglore', ctc: '3.6L'},
            { id: '2', jobTitle: 'Net Developer ', exp: '10 years', location: 'banglore', ctc: '3.6L'},
            { id: '3', jobTitle: 'Chief Financial Officer - CA - Joint Venture', exp: '10 years', location: 'banglore', ctc: '3.6L'},
            { id: '4', jobTitle: 'Chief Financial Officer - CA - Joint Venture', exp: '10 years', location: 'banglore', ctc: '3.6L'}
        ];
    })

    .controller('index-page-controller', function ($scope,$ionicPopup, $ionicPlatform, $ionicLoading,localStorageService, $http, $rootScope, $location, $ionicNavBarDelegate) {
        $scope.jobFeedClick = function() {
            if($rootScope.isLoggedIn) {
                $location.url("/app/jobListing/JobsFeed//");
            }
            else {
                $location.url("/app/login");
            }
        };
        var localSocial = localStorage.getItem('hello');
        var data = JSON.parse(localSocial);
        if (!$rootScope.isLoggedIn && data) {
            var obj = {};
            if(data.facebook) {
                obj.provide = 'facebook';
                obj.token = data.facebook.access_token;
            }
            if(data.google) {
                obj.provide = 'google';
                obj.token = data.google.access_token;
            }
            if(data.linkedin) {
                obj.provide = 'linkedin';
                obj.token = data.linkedin.access_token;
            }

            var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.signupWithSocialString, obj, {});
            responsePromise.success(function (dataFromServer, status, headers, config) {
                if (typeof dataFromServer.User !== "undefined") {
                    $rootScope.currUserID = dataFromServer.User.id;
                    var obj = {};
                    obj.username = dataFromServer.User.username;
                    obj.password = dataFromServer.User.password;
                    localStorageService.set('localUser', obj);
                    $rootScope.isLoggedIn = true;
                    var currentJobID = localStorageService.get('localJobID');
                    if (dataFromServer.Seeker.phone) {
                        if (currentJobID) {
                            $location.url("/app/jobView/" + currentJobID);
                        }
                        else {
                            $location.url("/app/index");
                        }
                    }
                    else {
                        $location.url("/app/profile");
                    }
                    $ionicLoading.hide();
                }
            });
            responsePromise.error(function (data, status, headers, config) {
                $scope.passreseterror = data.error;
                $ionicLoading.hide();
            });
        }


        $ionicPlatform.ready(function() {
            var localMenuData = localStorageService.get("menuSubmenuDataLocal");
            if (localMenuData) {
                var lastApiCallDate = new Date(new Date(localMenuData.apiCallDate).getTime() + 24 * 60 * 60 * 1000);
                var cuuDateCall = new Date(new Date().getTime() + 24 * 60 * 60 * 1000);
                var timeDiff = cuuDateCall - lastApiCallDate;
                var diffDays = Math.floor(timeDiff / (1000 * 3600 * 24));
                if (diffDays >= $rootScope.stringObject.daysDiff) {
                    getMenuData();

                }
                else {
                    $scope.category = localMenuData;
                }
            }
            else {
                getMenuData();
            }
        });

        function getMenuData() {
            $ionicLoading.show({
                template: '<i class="fa fa-spinner fa-spin"></i> Loading..'
            });
            var responsePromiseForCategoryList = $http.get($rootScope.stringObject.hostname + $rootScope.stringObject.indexPageString);
            responsePromiseForCategoryList.success(function (response, status, headers, config) {
                $scope.listData = response;
                $scope.category = [];
                $scope.categoryData = [];
                var categoryDataFromServer = [];
                for (var i = 0; i < response.length; i++) {
                    $scope.category[i] = {
                        id: response[i].Mainmenue.id,
                        name: response[i].Mainmenue.menu,
                        subCategory: []
                    };
                    for (var j = 0; j < response[i].Submenue.length; j++) {
                        $scope.category[i].subCategory.push({ "id": response[i].Submenue[j].id, "name": response[i].Submenue[j].menu });
                    }
                }

                localStorageService.set('menuSubmenuDataLocal', $scope.category);
                $ionicLoading.hide();
            });

            responsePromiseForCategoryList.error(function (data, status, headers, config) {
                $scope.error = data.error;
                $ionicLoading.hide();
            });
        }

        $scope.toggleGroup = function (category) {
            if ($scope.isCategoryShown(category)) {
                $scope.shownCategory = null;
            } else {
                $scope.shownCategory = category;
            }
        };

        $scope.isCategoryShown = function (category) {
            return $scope.shownCategory === category;
        };
    })

    .controller('jobListing-job-controller', function ($scope, $timeout, $rootScope, $state, $http, $location) {
        if ($rootScope.noConnection) {
            $ionicLoading.hide();
        }
        $scope.jobFeedClick = function() {
            if($rootScope.isLoggedIn) {
                $location.url("/app/jobListing/JobsFeed//");
            }
            else {
                $location.url("/app/login");
            }
        };
        $scope.type = '';
        $scope.hasMoreData = true;
        $rootScope.nodataMessage = null;
        $scope.subCategoryNameTitle = $state.params['subCategoryName'];
        $scope.jobListingData = [];
        $scope.page = 1;
        $scope.appliedJobData = [];
        if ($rootScope.isLoggedIn) {
            var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.getAppliedJob, $rootScope.localUser, {});
            responsePromise.success(function (dataFromServer, status, headers, config) {
                if (dataFromServer.length !== 0 && typeof dataFromServer[0].Jobs !== "undefined") {
                    for (var i = 0; i < dataFromServer.length; i++) {
                        $scope.appliedJobData[dataFromServer[i].Jobs.ID] = true;
                    }
                }
            });
            responsePromise.error(function (data, status, headers, config) {
                $scope.passreseterror = data.error;
            });
        }
        $scope.mutex = true;
        $scope.loadMore = function () {
            if ($scope.mutex == true && $scope.page == 1) {
                $scope.mutex = false;
                return;
            }
            if ($state.params['categoryID']) {
                if($state.params['categoryID'] == 'JobsFeed') {
                    $scope.type = 'jobfeed';
                    var responsePromiseForJobLisiting = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.jobListingString +"JobsFeed//page:" + $scope.page, $rootScope.localUser);
                    responsePromiseForJobLisiting.success(function (response, status, headers, config) {
                        if (response.length != 0 && response != 'fail') {

                            for (var i = 0; i < response.length; i++) {
                                if(response[i].Job) {
                                if (typeof $scope.appliedJobData[response[i].Job.ID] !== "undefined" && $scope.appliedJobData[response[i].Job.ID]) {
                                    response[i].isApplied = true;
                                }
                                else {
                                    response[i].isApplied = false;
                                }
                            }

                                if (response[i].Job.title.length > 20) {
                                    response[i].Job.title = response[i].Job.title.substr(0, 20) + "...";
                                }
                                if (response[i].Job.max_compen == 5000) {
                                    response[i].Job.max_compen = "No Bar";
                                }

                                $scope.jobListingData.push(response[i]);

                                if (response.length < 20) {
                                    $scope.hasMoreData = false;
                                    $scope.$broadcast('scroll.infiniteScrollComplete');
                                }
                            }
                            $scope.page++;
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                        else {
                            $rootScope.nodataMessage = "No job available";
                            $scope.hasMoreData = false;
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                    });

                    responsePromiseForJobLisiting.error(function (data, status, headers, config) {
                        $scope.error = data.error;
                    });
                }
                else {
                    $scope.type = 'listing';
                    var responsePromiseForJobLisiting = $http.get($rootScope.stringObject.hostname + $rootScope.stringObject.jobListingString + $state.params['categoryID'] + "/" + $state.params['subCategoryID'] + "/page:" + $scope.page);
                    responsePromiseForJobLisiting.success(function (response, status, headers, config) {
                        if (response.length != 0 && response != 'fail') {
                            for (var i = 0; i < response.length; i++) {
                                if (typeof $scope.appliedJobData[response[i].Job.ID] !== "undefined" && $scope.appliedJobData[response[i].Job.ID]) {
                                    response[i].isApplied = true;
                                }
                                else {
                                    response[i].isApplied = false;
                                }

                                if (response[i].Job.title.length > 20) {
                                    response[i].Job.title = response[i].Job.title.substr(0, 20) + "...";
                                }
                                if (response[i].Job.max_compen == 5000) {
                                    response[i].Job.max_compen = "No Bar";
                                }

                                $scope.jobListingData.push(response[i]);

                                if (response.length < 20) {
                                    $scope.hasMoreData = false;
                                    $scope.$broadcast('scroll.infiniteScrollComplete');
                                }
                            }
                            $scope.page++;
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                        else {
                            $rootScope.nodataMessage = "No job available";
                            $scope.hasMoreData = false;
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                    });

                    responsePromiseForJobLisiting.error(function (data, status, headers, config) {
                        $scope.error = data.error;
                    });
                }
            }
            else {
                $scope.type = 'filter';
                if ($rootScope.currentFilterJob) {
                    $rootScope.currentFilterJob.pageId = $scope.page;
                    var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.displayJob, $rootScope.currentFilterJob, {});
                    responsePromise.success(function (dataFromServer, status, headers, config) {
                        if (dataFromServer.length != 0) {
                            for (var i = 0; i < dataFromServer.length; i++) {
                                if (dataFromServer[i].Job.max_compen == 5000) {
                                    dataFromServer[i].Job.max_compen = "No Bar";
                                }
                                if (dataFromServer[i].Job.title.length > 20) {
                                    dataFromServer[i].Job.title = dataFromServer[i].Job.title.substr(0, 20) + "...";
                                }
                                $scope.jobListingData.push(dataFromServer[i]);
                            }
                            if (dataFromServer.length < 20) {
                                $scope.hasMoreData = false;
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                            }
                            $scope.page++;
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                        else {
                            $rootScope.nodataMessage = "No job available";
                            $scope.hasMoreData = false;
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        }
                    });
                    responsePromise.error(function (data, status, headers, config) {
                        $scope.passreseterror = data.error;
                    });
                }
                else {
                    $rootScope.nodataMessage = "No job available";
                    $scope.hasMoreData = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            }
        };

        $scope.$on('$stateChangeSuccess', function () {
            $scope.loadMore();
        });
    })
    .filter('range', function () {
        return function (input, total) {
            total = parseInt(total);
            for (var i = 0; i < total; i++)
                input.push(i);
            return input;
        };
    })
    .controller('profile-page-controller', function ($scope, $ionicPopover, $ionicPopup, $state, $http, $location, $rootScope, localStorageService, $ionicLoading) {
        $scope.User = {};
        $scope.User.exp_month = '';
        $scope.lengthMinify = function(str) {
            if(str) {
                if (str.length > 20)
                    str = str.substr(0, 20) + "...";
            }
            return str;
        }

        $scope.colleageList = $rootScope.colleageList;
        $scope.User.experience = 1;
        if ($rootScope.isLoggedIn) {
            $scope.$watch('User.engSkillsFilter', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var engskillsFilterData = [];
                        for(var filter = 0; filter < $rootScope.enggSkillsData.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.enggSkillsData[filter].name.toLowerCase());
                            if(boolResult) {
                                engskillsFilterData.push({ name : $rootScope.enggSkillsData[filter].name});

                            }
                        }
                        $scope.engSkillsFilter = engskillsFilterData;
                    }
                }
                else {
                    $scope.engSkillsFilter = $rootScope.enggSkillsData;
                }
            });

            $scope.$watch('User.nonengSkillsFilter', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var nonengSkillsFilterData = [];
                        for(var filter = 0; filter < $rootScope.nonEnggSkillsData.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.nonEnggSkillsData[filter].name.toLowerCase());
                            if(boolResult) {
                                nonengSkillsFilterData.push({ name : $rootScope.nonEnggSkillsData[filter].name});
                            }
                        }
                        $scope.nonengSkillsFilter = nonengSkillsFilterData;
                    }
                }
                else {
                    $scope.nonengSkillsFilter = $rootScope.nonEnggSkillsData;
                }
            });

            $scope.$watch('User.colleageList', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var colleageFilterData = [];
                        for(var filter = 0; filter < $rootScope.colleageList.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.colleageList[filter].collegeName.toLowerCase());
                            if(boolResult) {
                                colleageFilterData.push({ collegeName : $rootScope.colleageList[filter].collegeName});
                            }
                        }
                        $scope.colleageList = colleageFilterData;
                    }
                }
            });

            $scope.$watch('User.degreeList', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var degreeFilterData = [];
                        for(var filter = 0; filter < $rootScope.degreeList.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.degreeList[filter].degreeName.toLowerCase());
                            if(boolResult) {
                                degreeFilterData.push({ degreeName : $rootScope.degreeList[filter].degreeName});
                            }
                        }
                        $scope.degreeList = degreeFilterData;
                    }
                }
            });

            $scope.$watch('User.specificationList', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var specificationFilterData = [];
                        for(var filter = 0; filter < $rootScope.specificationList.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.specificationList[filter].specName.toLowerCase());
                            if(boolResult) {
                                specificationFilterData.push({ specName : $rootScope.specificationList[filter].specName});
                            }
                        }
                        $scope.specificationList = specificationFilterData;
                    }
                }
            });

            $scope.$watch('User.batchYearList', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var batchYearFilterData = [];
                        for(var filter = 0; filter < $scope.batchYearList.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($scope.batchYearList[filter].year);
                            if(boolResult) {
                                batchYearFilterData.push({ year : $scope.batchYearList[filter].year});
                            }
                        }
                        $scope.batchYearList = batchYearFilterData;
                    }
                }
            });

            $scope.$watch('User.preferredCityFilter', function (newValue, oldValue) {
                if (typeof newValue !== "undefined") {
                    if (newValue !== oldValue) {
                        var preferredCityFilterData = [];
                        for(var filter = 0; filter < $rootScope.showLocationData.length; filter++) {
                            var boolResult = new RegExp('^' + newValue.toLowerCase()).test($rootScope.showLocationData[filter].name.toLowerCase());
                            if(boolResult) {
                                preferredCityFilterData.push({ name : $rootScope.showLocationData[filter].name});
                            }
                        }
                        $scope.preferredCityFilter = preferredCityFilterData;
                    }
                }
                else {
                    $scope.preferredCityFilter = $rootScope.showLocationData;
                }
            });
            var obj = localStorageService.get('localUser');
            $scope.dataObject = obj;
            $ionicLoading.show({
                template: '<i class="fa fa-spinner fa-spin"></i> Loading..'
            });
            var responsePromiseGetProfile = $http.post($rootScope.stringObject.hostname + "/Seekers/profileForMobile", $scope.dataObject, {});
            responsePromiseGetProfile.success(function (dataFromServer, status, headers, config) {
                if (typeof dataFromServer.Seeker !== "undefined") {
                    $scope.User = { firstName: dataFromServer.Seeker.fname, lastName: dataFromServer.Seeker.lname, institute: dataFromServer.Seeker.institute,
                        currentOrganization: dataFromServer.Seeker.organization,
                        degreeName: dataFromServer.Seeker.degree,
                        exp_month: parseInt(dataFromServer.Seeker.exp_month),
                        exp_year: parseInt(dataFromServer.Seeker.exp_year),
                        notice_period : parseInt(dataFromServer.Seeker.notice_period),
                        currentCTC: parseInt(dataFromServer.Seeker.cur_ctc),
                        otherSkills: dataFromServer.Seeker.otherSkills,
                        specificationName: dataFromServer.QualificationsDetails.major,
                        mobile: parseInt(dataFromServer.Seeker.phone),
                        batchName: parseInt(dataFromServer.QualificationsDetails.to),
                        currentCity: dataFromServer.Seeker.city
                    };
                    $scope.User.experience = parseInt(dataFromServer.Seeker.isFresher);
                    $scope.User.engSkillsProfile = [];
                    $scope.User.nonSkillsProfile = [];
                    $scope.User.preferredCityProfile = [];
                    //$scope.engSkillsCount = 0;
                    if (dataFromServer.Seeker.enggSkills) {
                        $scope.engskillsStr = dataFromServer.Seeker.enggSkills;
                        if ($scope.engskillsStr.length > 20)
                            $scope.engskillsStr =$scope.engskillsStr.substr(0, 20) + "...";
                        var engSkillsObj = dataFromServer.Seeker.enggSkills.split(',');
                        for (var i = 0; i < engSkillsObj.length; i++) {
                            $scope.User.engSkillsProfile[engSkillsObj[i]] = true;
                        }
                    }

                    if (dataFromServer.Seeker.nonEnggSkills) {
                        $scope.nonengSkillsStr = dataFromServer.Seeker.nonEnggSkills;
                        if ($scope.nonengSkillsStr.length > 20)
                            $scope.nonengSkillsStr =$scope.nonengSkillsStr.substr(0, 20) + "...";
                        var nonengSkillsObj = dataFromServer.Seeker.nonEnggSkills.split(',');
                        for (var i = 0; i < nonengSkillsObj.length; i++) {
                            $scope.User.nonSkillsProfile[nonengSkillsObj[i]] = true;
                        }
                    }

                    if (dataFromServer.Seeker.precity) {
                        $scope.preCityStr = dataFromServer.Seeker.precity;
                        if ($scope.preCityStr.length > 20)
                            $scope.preCityStr =$scope.preCityStr.substr(0, 20) + "...";
                        var precityObj = dataFromServer.Seeker.precity.split(',');
                        for (var i = 0; i < precityObj.length; i++) {
                            $scope.User.preferredCityProfile[precityObj[i]] = true;
                        }
                    }
                    $ionicLoading.hide();
                }
            });
            responsePromiseGetProfile.error(function (data, status, headers, config) {
                $scope.passreseterror = data.error;
            });
            $scope.expMonthList = [];
            $scope.expYearList = [];
            for (var i = 0; i <= 11; i++) {
                $scope.expMonthList.push({ month: i});
            }
            for (var i = 0; i <= 40; i++) {
                $scope.expYearList.push({ year: i});
            }

            $scope.closePopupSucessProfile = function () {
                var currentJobID = localStorageService.get('localJobID');
                if (currentJobID) {
                    $location.url("/app/jobView/" + currentJobID);
                }
                else {
                    $location.url("/app/appliedJob");
                }
            }
            $scope.saveProfile = function (obj) {
                var isEnggSkills = false;
                var isNonEnggSkills = false;
                for (engSkill in obj.engSkillsProfile) {
                    isEnggSkills = true;
                }

                for (nonEng in obj.nonSkillsProfile) {
                    isNonEnggSkills = true;
                }
                $ionicLoading.show({
                    template: '<i class="fa fa-spinner fa-spin"></i> Loading..'
                });
                var isValidate = true;

                if (!obj.firstName) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid First Name', 'You have left first name field blank');
                    isValidate = false;
                    return false;
                }

                if (!obj.lastName) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Last Name', 'You have left last name field blank');
                    isValidate = false;
                    return false;
                }

                if (!obj.institute) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Institute', 'Please select an institute from dropdown menu');
                    isValidate = false;
                    return false;
                }

                if (!obj.degreeName) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Degree', 'Please select a degree from dropdown menu');
                    isValidate = false;
                    return false;
                }

                if (!obj.specificationName) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Major', 'Please select a major stream from dropdown menu');
                    isValidate = false;
                    return false;
                }

                if (!obj.batchName) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Passout Batch', 'Please select your passout batch from dropdown menu');
                    isValidate = false;
                    return false;
                }

                if (obj.experience == 0) {
                    if (!obj.currentOrganization) {
                        $ionicLoading.hide();
                        $rootScope.showAlert('Invalid Organization', 'Please fill in your current/last organization name');
                        isValidate = false;
                        return false;
                    }

                    if (!obj.currentCTC || obj.currentCTC == 0 || obj.currentCTC > 100 ) {
                        $ionicLoading.hide();
                        $rootScope.showAlert('Invalid CTC', 'Your CTC (current/last) should be between INR 0 L to 100 L');
                        isValidate = false;
                        return false;
                    }

                    if (!obj.notice_period > 12 ) {
                        $ionicLoading.hide();
                        $rootScope.showAlert('Invalid Notice Period', 'Enter Notice Period below 12');
                        isValidate = false;
                        return false;
                    }

                    if (obj.exp_month == 0 && obj.exp_year == 0) {
                        $ionicLoading.hide();
                        $rootScope.showAlert('Invalid Experience', 'Your experience should be greater than 0 months');
                        isValidate = false;
                        return false;
                    }
                }
                if (!obj.mobile) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Mobile No', 'Please enter a valid 10 digit mobile no');
                    isValidate = false;
                    return false;
                }
                if (!/^\d{10}$/.test(obj.mobile)) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Mobile No', 'Please enter a valid 10 digit mobile no');
                    isValidate = false;
                    return false;
                }

                if (!obj.currentCity) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid City', 'Please select your current city from dropdown menu');
                    isValidate = false;
                    return false;
                }

                if (!isEnggSkills && !isNonEnggSkills && !obj.otherSkills) {
                    $ionicLoading.hide();
                    $rootScope.showAlert('Invalid Skills', 'You need to select at-least one skill from engineering / non-engineering or other');
                    isValidate = false;
                    return false;
                }

                if (isValidate) {
                    var engskillsStr = '';
                    var nonengSkillsStr = '';
                    var preCityStr = '';
                    for (preCity in obj.preferredCityProfile) {
                        if (preCity) {
                            if (obj.preferredCityProfile[preCity]) {
                                preCityStr += preCity + ",";
                            }
                        }
                    }
                    preCityStr = preCityStr.substring(0, preCityStr.length - 1);
                    for (engSkill in obj.engSkillsProfile) {
                        if (engSkill) {
                            if (obj.engSkillsProfile[engSkill]) {
                                engskillsStr += engSkill + ",";
                            }
                        }
                    }
                    engskillsSubStr = engskillsStr.substring(0, engskillsStr.length - 1);
                    for (nonSkill in obj.nonSkillsProfile) {
                        if (nonSkill) {
                            if (obj.nonSkillsProfile[nonSkill]) {
                                nonengSkillsStr += nonSkill + ",";
                            }
                        }
                    }
                    nonengskillsSubStr = nonengSkillsStr.substring(0, nonengSkillsStr.length - 1);
                    obj.engSkills = engskillsSubStr;
                    obj.nonSkills = nonengskillsSubStr;
                    obj.preCities = preCityStr;
                    var localCredintals = localStorageService.get('localUser');
                    obj.username = localCredintals.username;
                    obj.password = localCredintals.password;
                    var responsePromise = $http.post($rootScope.stringObject.hostname + $rootScope.stringObject.updateProfile, obj, {});
                    responsePromise.success(function (dataFromServer, status, headers, config) {
                        if (dataFromServer == 'Success') {
                            $ionicPopup.show({
                                template: 'Successfully updated your profile.',
                                title: 'Congratulations!',
                                scope: $scope,
                                buttons: [
                                    {
                                        text: 'Ok',
                                        type: 'button-positive',
                                        onTap: function () {
                                            return $scope.closePopupSucessProfile()
                                        }
                                    }
                                ]
                            });
                            localStorageService.set('isJobFeed', 'yes');
                        }
                        else if(dataFromServer == 1) {
                            $ionicPopup.show({
                                template: 'Successfully updated your profile. Please upload resume by visiting JobsIIT website.',
                                title: 'Congratulations!',
                                scope: $scope,
                                buttons: [
                                    {
                                        text: 'Ok',
                                        type: 'button-positive',
                                        onTap: function () {
                                            return $scope.closePopupSucessProfile()
                                        }
                                    }
                                ]
                            });
                        }
                        else {
                            $rootScope.showAlert('Message', 'Internal Server Error : try again later');
                        }

                        $ionicLoading.hide();
                    });
                    responsePromise.error(function (data, status, headers, config) {
                        $scope.passreseterror = data.error;
                        $ionicLoading.hide();
                    });
                }

            };

            $scope.$watch('User.experience', function (newValue, oldValue) {
                $scope.addUserSuccess = null;
                if (typeof newValue !== "undefined") {
                    if (newValue == 0) {
                        $scope.User.experience = 0;
                    }
                    if (newValue == 1) {
                        $scope.User.experience = 1;
                    }
                }
            });

            $scope.uploadResume = function() {
                var localObject = localStorageService.get('localUser');
                var target = '_blank';
                if($rootScope.stringObject.mobileOrWebsite == 'mobile') {
                    target = '_system';
                }
                if (localObject) {
                    var ref = window.open($rootScope.stringObject.hostname + "/seekers/uploadResumeFromMobile/" + localObject.username + "/" + localObject.password, target, 'location=yes,toolbar=yes');
                }
            }
            var cuurDate = new Date();
            var highBound = parseInt(cuurDate.getFullYear()) + 5;
            $scope.batchYearList = [];
            for (var i = 1970; i <= highBound; i++) {
                $scope.batchYearList.push({ year: i});
            }
            $scope.showHidePopup = function (templateUrl) {
                $scope.activePopUp = $ionicPopup.show({
                    templateUrl: templateUrl,
                    title: 'Select',
                    scope: $scope,
                    buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
                        text: 'Cancel',
                        type: 'button-default',
                        onTap: function(e) {
                            return $rootScope.closePopup()
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function(e) {
                            return profilePopupValue(templateUrl)
                        }
                    }]
                });
            };

            function profilePopupValue(templateUrl) {
                if(templateUrl == 'locationList.html') {
                    var preCityStr = '';
                    for (preCity in $scope.User.preferredCityProfile) {
                        if (preCity) {
                            if ($scope.User.preferredCityProfile[preCity]) {
                                preCityStr += preCity + ",";
                            }
                        }
                    }
                    if (preCityStr.length > 25)
                        preCityStr = preCityStr.substr(0, 20) + "...";
                    $scope.preCityStr = preCityStr;
                }
                if(templateUrl == 'engskillsList.html') {
                    var engskillsStr = '';
                    for (engSkill in $scope.User.engSkillsProfile) {
                        if (engSkill) {
                            if ($scope.User.engSkillsProfile[engSkill]) {
                                engskillsStr += engSkill + ",";
                            }
                        }
                    }
                    if (engskillsStr.length > 20)
                        engskillsStr = engskillsStr.substr(0, 20) + "...";
                    $scope.engskillsStr = engskillsStr;
                }

                if(templateUrl == 'nonengskillsList.html') {
                    var nonengSkillsStr = '';
                    for (nonSkill in $scope.User.nonSkillsProfile) {
                        if (nonSkill) {
                            if ($scope.User.nonSkillsProfile[nonSkill]) {
                                nonengSkillsStr += nonSkill + ",";
                            }
                        }
                    }
                    if (nonengSkillsStr.length > 20)
                        nonengSkillsStr = nonengSkillsStr.substr(0, 20) + "...";
                    $scope.nonengSkillsStr = nonengSkillsStr;
                }
                return true;
            }

            window.onpopstate=function() {
                if($scope.activePopUp) {
                    $scope.activePopUp.close();   //Close Popup when user tap on browser back button....
                }
            }
        }
        else {
            $location.url("app/index");
        }
    });
